
/***************************************************************************
*   ܣ12864LCDʾ
****************************************************************************/
#include<pic.h> 
__CONFIG(0x1832);
//оƬ֣Źأϵʱأѹ̹أܣ4MHS

#define  rs  	RA0                    	//LCD/ƿ
#define  rw  	RA1                    	//LCDĶ/дƿ
#define  e   	RA2                    	//LCDʹܿ
#define  psb 	RA3                    	//ͨŷʽƿ
#define  rst 	RA4                    	//帴λ-----fanxiang
#define  nop()  asm("nop")          	//ղ


const unsigned char TAB1A[ ] = {"****"};
const unsigned char TAB1B[ ] = {"QQ634503119"};

const unsigned char TAB1C[ ] = {"**Ƭ**"};
const unsigned char TAB1D[ ] = {"ӭĻݹˣ"};
unsigned int lcd_x;                	//LCDҳַĴ
unsigned int lcd_y;                	//LCDеַĴ
bit busy;                         	//LCDæ־λ

void init();                        //I/Oú
void lcd_init();                    //LCDʼ
void clear_p();                     //
void writelcd(const unsigned char *pt);	   		//LCDдַ
void wr_zb();                       //йʾú
void flash();                       //LCDʾ˸
void send_d(unsigned char x);       //һֽʾ
void send_i(unsigned char x);       //һֽڿ
void chk_busy();                    //LCDǷæ
void delay();                       //ʱ1֮ʱ;ʾ
void delay1();                      //ʱ2Ծʾ˸

/****************************************************************************
*     ƣmain() 
*     ܣ
* ڲ
* ڲ
* ˵    
****************************************************************************/
void main()
{
	init();    							//I/Oú
	while (1)
	{
		lcd_init();                  	//LCDʼ
//		clear_p();                   	//
		send_i(0x81);				 	//1
		writelcd(TAB1A);
		send_i(0x90);					//2
		writelcd(TAB1B); 
		send_i(0x88);					//3
		writelcd(TAB1C);
		send_i(0x98);					//4
		writelcd(TAB1D);
		delay();                     	//ӳʾһʱ
//		flash();                     	//ʾ˸
//		clear_p();                   	//
	}
}

/****************************************************************************
*     ƣinit() 
*     ܣI/Oڳʼ
* ڲ
* ڲ
* ˵    
****************************************************************************/
void init()
{	
	ADCON1 = 0X07;                      //AΪͨI/O
	TRISA = 0X10;                       //AΪ
	TRISD = 0X00;                       //DΪ

}


/****************************************************************************
*     ƣlcd_init() 
*     ܣLCDʼ
* ڲ
* ڲ
* ˵    
****************************************************************************/
void lcd_init()
{
	rst = 0;                            //λLCD
	delay();                          	//֤λҪʱ
	rst = 1;                            //ָLCD
	nop();
	psb = 1;                            //LCDΪ8λͨ
	send_i(0x30);                     	//ָ
	send_i(0x01);                     	//ʾ
	send_i(0x06);                     	//ָдȡʱƶ
	send_i(0x0c);                     	//ʾع꣬˸
}

/****************************************************************************
*     ƣwr_zb() 
*     ܣʾ
* ڲ
* ڲ
* ˵    
****************************************************************************/
void wr_zb()
{
	send_i(lcd_y);
	send_i(lcd_x);
}

/****************************************************************************
*     ƣflash() 
*     ܣʾ˸
* ڲ
* ڲ
* ˵    
****************************************************************************/
void flash()
{
	send_i(0x08);                  //ʾ
	delay1();                      //ӳһʱ
	send_i(0x0c);                  //ʾ
	delay1();delay1();             //ӳʾʱ
	send_i(0x08);                  //ʾ
	delay1();
	send_i(0x0c);                  //ʾ
	delay1();delay1();
	send_i(0x08);                  //ʾ
	delay1();
	send_i(0x0c);                  //ʾ
	delay1();delay1();
	
}

/****************************************************************************
*     ƣclear_p()
*     ܣ
* ڲ
* ڲ
* ˵    
****************************************************************************/
void clear_p()
{
	send_i(0x1);                   //ʾ
	send_i(0x34);                  //չָ
	send_i(0x30);                  //ָ
}

/****************************************************************************
*     ƣsend_d() 
*     ܣдһֽݵLCD
* ڲunsigned char x ַ
* ڲ
* ˵    
****************************************************************************/
void send_d(unsigned char x)
{
	chk_busy();                  	//LCDǷæ
	rs = 1;                        	//øֽʾ
	rw = 0;                        	//øôβΪд
	PORTD = x;                     	//ݿPORTD
	e = 1;                         	//ʹ
	nop();
	nop();
	nop();
	e = 0;                         	//ֹ
}

/****************************************************************************
*     ƣsend_i() 
*     ܣдһֽLCD
* ڲunsigned char x ַ
* ڲ
* ˵    
****************************************************************************/
void send_i(unsigned char x)
{
	chk_busy();                  	//LCDǷæ
	rs = 0;                        //øֽΪ
	rw = 0;                        //ô˴βΪд
	PORTD = x;                     //ݿPORTD
	e = 1;                         //ʹ
	nop();
	nop();
	nop();
	e = 0;                         //ֹ
}

/****************************************************************************
*     ƣchk_busy() 
*     ܣLCDǷæ
* ڲ
* ڲ
* ˵    
****************************************************************************/
void chk_busy()
{
	busy = 1;                      //λæ־λ
	TRISD = 0XFF;                  //ͨΪ
	rs = 0;                        //øֽΪ
	rw = 1;                        //ô˴βΪ
	while (busy)
	{
		nop();nop();nop();
		e = 1;                   	//ʹ
		nop();nop();nop();
		if (!RD7) busy = 0;       	//LCDǷæ
		nop();nop();nop();
		e = 0;                   	//ֹ
	}
	e = 0;                         	//ֹ
	TRISD = 0X00;                  	//ָͨΪ
}

/****************************************************************************
*     ƣdelay() 
*     ܣʱ
* ڲ
* ڲ
* ˵    
****************************************************************************/
void delay()
{
	int i;
	for (i = 0;i < 5000;i++);
}

/****************************************************************************
*     ƣdelayl() 
*     ܣʱ
* ڲ
* ڲ
* ˵    
****************************************************************************/
void delay1()
{
	int i;
	for (i = 0;i < 10;i++)
	{
		delay();               //ʱ
	}
}

/****************************************************************************
*     ƣ writelcd
*     ܣ LCDʾַ
* ڲconst unsigned char *pt ַ׵ַ
* ڲ
* ˵    
****************************************************************************/
void writelcd(const unsigned char *pt)
{
    while(*pt)			//Ƿﵽַ
        send_d(*pt++);  //ݸlcd
}
